;------------------------------------------------------------------;
;                                                                  ;
; Banchor: The Hellspawn                                           ;
; Version 1.10                                                     ;
;                                                                  ;
; Copyright (c)2004-2009 James Vernon                              ;
; Written and Programmed by James Vernon <jamesv82@iprimus.com.au> ;
; http://www.jvti.org                                              ;
;                                                                  ;
;------------------------------------------------------------------;

;#define BREAK push af \ push bc \ ld a,$F7 \ call directIn \ bit 0,a \ jr nz,$+8 \ call waitKey \ call waitKey \ pop bc \ pop af
#define BREAK
;#define BREAK_ALL push af \ call waitKey \ pop af
;#define INVINCIBLE

;------------------------------------------------
; Include Files
;------------------------------------------------
#include "ti86.inc"
#include "zbdat2.inc"
#include "vars.asm"                             ; Variables and Other Equates

;------------------------------------------------
; Misc Defines
;------------------------------------------------
graymem1                                = $8000
graymem2                                = $8400
videoram                                = $F800
videoram2                               = $FC00
buffer1                                 = $8800
buffer2                                 = $8C00
_getcsc                                 = _get_key

.org    _asm_exec_ram

        nop
        jp      start
.dw     0
.dw     title

title:  .db "Banchor: The Hellspawn",0

start:
        call    _runindicoff

        ld      hl,mapsFileName-1               ; HL => Maps file name
        rst     20h
        rst     10h
        ret     c                               ; If maps are missing, quit

        ld      hl,dataFileName-1               ; HL => Data 1 file name
        rst     20h
        rst     10h
        ret     c                               ; If maps are missing, quit

        ld      hl,dataFileName2-1              ; HL => Data 2 file name
        rst     20h
        rst     10h
        ret     c                               ; If maps are missing, quit

        ld      hl,mapsFileName-1               ; HL => Maps file name
        rst     20h
        rst     10h
        ret     c                               ; If maps are missing, quit

        ld      hl,saveFileName-1               ; HL => Saved game file name
        rst     20h
        rst     10h
        ret     c                               ; If saved game file is missing, quit
        call    _ex_ahl_bde                     ; AHL => Save file
        call    _get_word_ahl                   ; DE = Length of save file
        call    _set_abs_src_addr               ; Set source address of data to copy
        sub     a                               ; RAM page 0
        ld      hl,saveGameData                 ; HL => Where to copy save data
        call    _set_abs_dest_addr              ; Set destination address of data to copy
        ld      hl,saveGameSize                 ; HL = Number of bytes to copy
        call    _set_mm_num_bytes               ; Set it
        call    _mm_ldir                        ; Load save data from file

        call    loadZBDat                       ; Load "zbdat"

        call    openGray                        ; Install Grayscale

titleScreen:
; Show title screen
        ld      hl,titlePic                     ; HL => Compressed title pic data
        ld      de,buffer1                      ; DE => Where to extract to
        call    extractShowPic                  ; Extract and show title picture

titleLoop:
        call    waitKey                         ; Wait for key press
        cp      GK_F5                           ; Was [F5] pressed?
        jr      z,checkNewGame                  ; If so, confirm to start a new game
        cp      GK_F1                           ; Was [F1] pressed?
        jr      nz,titleLoop                    ; If not, loop again

titleDone:
        ld      a,(mapNo)                       ; A = Map number
        inc     a                               ; Check to see if it's 255
        jr      nz,loadGame                     ; If not, we can load the game
        jr      newGame

checkNewGame:
; Show different bottom section of title pic
        ld      hl,titlePic2                    ; HL => Compressed title pic data
        ld      de,buffer1+((64-8)*16)          ; DE => Where to extract to
        call    extractShowPic                  ; Extract and show new title pic
        call    waitKey                         ; Wait for key press
        cp      GK_ENTER                        ; Was [ENTER] pressed?
        jr      nz,titleScreen                  ; If not, go back to normal title screen

newGame:
        ld      hl,items                        ; HL => Item data
        ld      b,NUM_ITEMS                     ; B = Number of items to clear
        call    _ld_hl_bz                       ; Clear all items
        xor     a
        ld      (mapNo),a                       ; Start on map 0
        sbc     hl,hl                           ; HL = 0
        ld      (gold),hl                       ; Reset gold
        inc     a                               ; A = 1
        ld      (playerDir),a                   ; Face player down
        ld      (hearts),a                      ; Start with only 1 heart
        ld      a,3
        ld      (maxHearts),a                   ; Start with maximum hearts of 3
        ld      hl,INI_YX_POS                   ; HL = Start X & Y coords
        ld      (enterMapCoords),hl             ; Save it
; Load chests
        ld      hl,mapsFileName-1
        rst     20h
        rst     10h
        call    _ex_ahl_bde
        call    _get_word_ahl
        ld      de,1
        add     hl,de
        adc     a,0
        call    _set_abs_src_addr
        sub     a
        ld      hl,chests
        call    _set_abs_dest_addr
        ld      hl,300
        call    _set_mm_num_bytes
        call    _mm_ldir
        call    _ram_page_1
; Clear changeList
        call    clearChangeList

loadGame:
        call    updateItems                     ; Check what items player has
        xor     a                               ; A = 0
        ld      (hurt),a
        ld      (attacking),a
        ld      (frame),a
        ld      (areaNum),a
        ld      (demon),a
        ld      hl,(enterMapCoords)
        ld      (y),hl                          ; Load Player X & Y coords
        call    newMap                          ; Load new map
        call    grayDrawMap                     ; Draw map
        call    copyBuffers                     ; Copy buffers
#include "maingame.asm"                         ; Main Game Loop

quit:
        call    _clrscrn
        set     graphdraw,(iy+graphflags)
; Save game
        ld      hl,saveFileName-1               ; HL => Saved game file name
        rst     20h
        rst     10h
        call    _ex_ahl_bde                     ; AHL => Save file
        call    _get_word_ahl                   ; DE = Length of save file
        call    _set_abs_dest_addr              ; Set destination address of data to copy
        sub     a                               ; RAM page 0
        ld      hl,saveGameData                 ; HL => Save data from current game
        call    _set_abs_src_addr               ; Set source address of data to copy
        ld      hl,saveGameSize                 ; HL = Number of bytes to copy
        call    _set_mm_num_bytes               ; Set it
        call    _mm_ldir                        ; Save game data
        jp      closeGray                       ; Uninstall Grayscale and quit back to OS

loadZBDat:
        ld      hl,dataFileName-1
        ld      de,$9200-$8000
        jr      loadDatFile
loadZBDat2:
        ld      hl,dataFileName2-1
        ld      de,$A200-$8000
loadDatFile:
        ld      (_@datDest),de
        rst     20h
        rst     10h
        ret     c                               ; If data file missing, quit
        call    _ex_ahl_bde                     ; AHL => Data file
        call    _get_word_ahl                   ; DE = Length of data file
        call    _set_abs_src_addr               ; Set source address of data to copy
        ld      a,1                             ; We want RAM page 1
        ld      hl,$0000                        ; AHL => Destination
_@datDest                               = $-2
        call    _set_abs_dest_addr              ; Set destination address of data to copy
        xor     a                               ; A = 0
        ex      de,hl                           ; AHL = Number of bytes to copy
        call    _set_mm_num_bytes               ; Set number of bytes to copy
        call    _mm_ldir                        ; Load data file to RAM page 1
        jp    _ram_page_1                       ; Load RAM page 1

extractShowPic:
        ld      ix,_plotsscreen                 ; IX => Temp compression data
        call    huffExtr                        ; Extract picture data
        call    copyBuffers
        jp      showGray                        ; Show new screen

;------------------------------------------------
; Include Files (code)
;------------------------------------------------
#include "anim.asm"                             ; Animation Routines
#include "area.asm"                             ; Area Name Routines
#include "buffers.asm"                          ; Triple Buffering Routines
#include "change.asm"                           ; Change List Routines
#include "chests.asm"                           ; Chest Routines
#include "danazar.asm"                          ; Anazar Demon Routines
#include "dbanchor.asm"                         ; Banchor Demon Routines
#include "dbelkath.asm"                         ; Belkath Demon Routines
#include "ddezemon.asm"                         ; Dezemon Demon Routines
#include "demon.asm"                            ; Demon Routines
#include "dheath.asm"                           ; King Heath Demon Routines
#include "dwendeg.asm"                          ; Wendeg Demon Routines
#include "enemy.asm"                            ; Enemy Routines
#include "enemyai.asm"                          ; Enemy AI Scripts
#include "gray.asm"                             ; Flicker-Free Four Level Grayscale Routines
#include "huffextr.asm"                         ; Huffman Decompression by Jimmy Mrdell
#include "inven.asm"                            ; Inventory Screen Routines
#include "io.asm"                               ; Input/Output Routines
#include "map.asm"                              ; Map Routines
#include "object.asm"                           ; Object Routines
#include "player.asm"                           ; Player Routines
#include "random.asm"                           ; Random Routines
#include "sprite.asm"                           ; Grayscale Sprite Routines
#include "talk.asm"                             ; Talking Routines

;------------------------------------------------
; Saved game data
;------------------------------------------------
saveGameData:

mapNo:                                  .db     255
playerDir:                              .db     0
enterMapCoords:                         .dw     0
hearts:                                 .db     0
maxHearts:                              .db     0
gold:                                   .dw     0
items:                                  .db     0,0,0,0,0,0,0,0,0,0,0,0
crystals:                               .db     0,0,0,0,0
chests:                                 .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
changeList:                             .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
                                        .db     0,0,0,0,0,0,0,0,0,0

saveGameSize                            = $-saveGameData

bluntSword                              = items+0
superiorSword                           = items+1
legendarySword                          = items+2
woodenShield                            = items+3
ironShield                              = items+4
lightArmor                              = items+5
heavyArmor                              = items+6
aquaBoots                               = items+7
wingedBoots                             = items+8
ringOfMight                             = items+9
ringOfThunder                           = items+10
heartPiece                              = items+11

NUM_ITEMS                               = chests-items

;------------------------------------------------
; External File Names
;------------------------------------------------
dataFileName:
.db     5,"zbdat"

dataFileName2:
.db     6,"zbdat2"

mapsFileName:
.db     6,"zbmaps"

saveFileName:
.db     6,"zbsave"

.end
