;---------------------------------------------------------------;
;                                                               ;
; Banchor                                                       ;
; Triple Buffering Routines                                     ;
;                                                               ;
;---------------------------------------------------------------;

;------------------------------------------------
; ShowGray - Copy graymem to videoram
;
; Author:   David Phillips <david@acz.org>
; Input:    None
; Output:   None
;------------------------------------------------
ShowGray:
        ld      hl,GrayMem1
        ld      de,VideoRam
        ld      bc,2048
        ldir
        ret

;------------------------------------------------
; CopyBuffers - Copy buffers to graymem
;
; Author:   David Phillips <david@acz.org>
; Input:    None
; Output:   None
;------------------------------------------------
CopyBuffers:
        ld      hl,Buffer1
        ld      de,GrayMem1
        ld      bc,2048
        ldir
        ret

;------------------------------------------------
; Clear Buffers - Clear buffers
;
; Author:   David Phillips <david@acz.org>
; Input:    None
; Output:   None
;------------------------------------------------
ClearBuffers:
        ld      hl,Buffer1
        ld      de,Buffer1+1
        ld      bc,2047
        ld      (hl),0
        ldir
        ret

.end
