;---------------------------------------------------------------;
;                                                               ;
; Banchor                                                       ;
; Variables and Other Equates                                   ;
;                                                               ;
;---------------------------------------------------------------;

;------------------------------------------------
; Defines to what player can walk over
;------------------------------------------------
NEED_AQUA                               = WATER1
NEED_WINGED                             = STONE1
CANT_WALK_OVER                          = WATERFALL1

;------------------------------------------------
; Defines for sword strengths
;------------------------------------------------
SWORD_B_STR                             = 3
SWORD_S_STR                             = 6
SWORD_L_STR                             = 18

;------------------------------------------------
; Initialisation defines
;------------------------------------------------
INI_ATTACK                              = 10
INI_HEART_LEVEL                         = ONE_HEART
INI_HURT                                = 16
INI_YX_POS                              = 24*256+16
MAP_REX_HOUSE                           = 32
INI_YX_POS_REX_HOUSE                    = 96*256+16

;------------------------------------------------
; Misc defines
;------------------------------------------------
AREA_WAIT                               = 200
BULLET_DAMAGE                           = ONE_HEART/4
ENEMY_WALL                              = WATER1
GOLD_MAX                                = 50000
TXT_DEAD                                = 26
MAX_CHANGES                             = 70

;------------------------------------------------
; Demon defines
;------------------------------------------------
INI_HEATH_YX                            = 56*256+8
INI_HEATH_HEALTH                        = 350
HEATH_DAMAGE                            = ONE_HEART/2
HEATH_GOLD                              = 2000

INI_DEZEMON_YX                          = 56*256+8
INI_DEZEMON_HEALTH                      = 500
DEZEMON_DAMAGE                          = ONE_HEART
DEZEMON_GOLD                            = 5000

INI_WENDEG_YX                           = 56*256+9
INI_WENDEG_HEALTH                       = 750
WENDEG_DAMAGE                           = (ONE_HEART*3)/2
WENDEG_GOLD                             = 10000

INI_BELKATH_YX                          = 56*256+10
INI_BELKATH_HEALTH                      = 1000
BELKATH_DAMAGE                          = ONE_HEART*2
BELKATH_GOLD                            = 15000

INI_ANAZAR_YX                           = (DSXMIN+8)*256+20
INI_ANAZAR_HEALTH                       = 2000
ANAZAR_DAMAGE                           = (ONE_HEART*5)/2
ANAZAR_GOLD                             = 20000

INI_BANCHOR_YX                          = 56*256+8
INI_BANCHOR_HEALTH                      = 4000
BANCHOR_DAMAGE                          = ONE_HEART*3
BANCHOR_GOLD                            = 0

;------------------------------------------------
; Item cost defines
;------------------------------------------------
COST_SUPERIOR_SWORD                     = 15000
COST_LEGENDARY_SWORD                    = 35000
COST_IRON_SHIELD                        = 22000
COST_LIGHT_ARMOR                        = 10000
COST_HEAVY_ARMOR                        = 30000
COST_AQUA_BOOTS                         = 20000
COST_WINGED_BOOTS                       = 40000
COST_RING_OF_MIGHT                      = 8000
COST_RING_OF_THUNDER                    = 25000
COST_HEART_CONTAINER                    = 2000
COST_WELL                               = 100

;------------------------------------------------
; Enemy definitions
;------------------------------------------------
MAX_ENEMIES                             = 4
ENEMY_ENTRY_SIZE                        = 10
E_DIR                                   = 0
E_X                                     = 1
E_Y                                     = 2
E_HEALTH                                = 3
E_AI1CNT                                = 4
E_AI1OFF                                = 5
E_AI2CNT                                = 6
E_AI2OFF                                = 7
E_SPEED                                 = 8
E_HURT                                  = 9
enemyTable                              = $9200-(ENEMY_ENTRY_SIZE*MAX_ENEMIES)

;------------------------------------------------
; Enemy bullet definitions
;------------------------------------------------
MAX_BULLETS                             = 2
BULLET_ENTRY_SIZE                       = 3
B_DIR                                   = 0
B_X                                     = 1
B_Y                                     = 2
bulletTable                             = enemyTable-(BULLET_ENTRY_SIZE*MAX_BULLETS)

;------------------------------------------------
; Animation definitions
;------------------------------------------------
MAX_ANIMS                               = 4
ANIM_ENTRY_SIZE                         = 3
A_CNT                                   = 0
A_X                                     = 1
A_Y                                     = 2
animTable                               = bulletTable-(ANIM_ENTRY_SIZE*MAX_ANIMS)

;------------------------------------------------
; Demon object definitions
;------------------------------------------------
MAX_DEMON_OBJECTS                       = 6
DEMON_ENTRY_SIZE                        = 4
D_DIR                                   = 0
D_X                                     = 1
D_Y                                     = 2
D_SPECIAL                               = 3
demonTable                              = animTable-(DEMON_ENTRY_SIZE*MAX_DEMON_OBJECTS)

;------------------------------------------------
; Map declarations
;------------------------------------------------
MAPS_OFFSET                             = 301
MAP_SIZE                                = 160
map                                     = $9000         ; 128   8 x 16 tiles
mapInfo                                 = map+128
upEdge                                  = mapInfo+0     ; 1
downEdge                                = mapInfo+1     ; 1
leftEdge                                = mapInfo+2     ; 1
rightEdge                               = mapInfo+3     ; 1
numWarps                                = mapInfo+4     ; 1
warps                                   = mapInfo+5     ; 16    4 warps x 4 bytes each
numPeople                               = mapInfo+21    ; 1
people                                  = mapInfo+22    ; 8     4 people x 2 bytes each
enemyType                               = mapInfo+30    ; 1
area                                    = mapInfo+31    ; 1

;------------------------------------------------
; In-game variables
;------------------------------------------------
vars                                    = map+MAP_SIZE
choice                                  = vars+000      ; 1     Main menu choice
y                                       = vars+001      ; 1     Player Y coord
x                                       = vars+002      ; 1     Player X coord
frame                                   = vars+003      ; 1     Frame counter
walkCnt                                 = vars+004      ; 1     Walk counter
attacking                               = vars+005      ; 1     Player attack flag
playerOffset                            = vars+006      ; 1     Player offset in map
string                                  = vars+007      ; 6     String buffer mem
hurt                                    = vars+013      ; 1     Player hurt flag
areaNum                                 = vars+014      ; 1     Area number
randData                                = vars+015      ; 2     Random data used in "random" routines
ai1                                     = vars+017      ; 1     AI script 1 for enemies
ai2                                     = vars+018      ; 1     AI script 2 for enemies
aiCnt                                   = vars+019      ; 1     Counter for AI scripts
aiOff                                   = vars+020      ; 1     Flag for AI scripts
collide1                                = vars+021      ; 4     Collision detection object
collide2                                = vars+025      ; 4     Collision detection object
attackStrength                          = vars+029      ; 1     Player's attack strength
heartLevel                              = vars+030      ; 1     Intermediate heart level the player doesn't see
dy                                      = vars+031      ; 1     Demon Y position
dx                                      = vars+032      ; 1     Demon X position
demonWarp                               = vars+033      ; 3     Data for where to warp to when demon finished
dHealth                                 = vars+036      ; 2     Demon health
demon                                   = vars+038      ; 1     Demon number player is fighting
dCnt                                    = vars+039      ; 1     Demon counter
dFlags                                  = vars+040      ; 1     Demon flags
aiCntOther                              = vars+041      ; 1     Copy of other AI counter

#define DIRECTIN_8586
#define GETKEY_8586

#include "directin.inc"
#include "get_key.inc"

.end
