;---------------------------------------------------------------;
;                                                               ;
; Banchor                                                       ;
; Data File                                                     ;
;                                                               ;
;---------------------------------------------------------------;

.org    $9200

#include "mapspr.asm"

titlePic:
#include "title.asm"

titlePic2:
#include "title2.asm"

DSXMIN                                  = 16
DSXMAX                                  = 128-16
D_INI_YX                                = ((DSXMAX-DSXMIN)/2+DSXMIN-4)*256+64-8

;------------------------------------------------
; Tile equates
;------------------------------------------------
BLACK                                   = (sprCrevice-startMapSprites)/16
BLOCKWALL                               = (sprBlock-startMapSprites)/16
CHESTCLOSED                             = (sprChestClosed-startMapSprites)/16
CHESTOPEN                               = (sprChestOpen-startMapSprites)/16
DGRAY                                   = (sprDGray-startMapSprites)/16
DOOROPENDOWN                            = (sprDoorDown-startMapSprites)/16
DOOROPENUP                              = (sprDoorUp-startMapSprites)/16
DOORCLOSEDUP                            = (sprClosedDoorUp-startMapSprites)/16
LAVA1                                   = (sprLava1-startMapSprites)/16
LAVA2                                   = (sprLava2-startMapSprites)/16
LGRAY                                   = (sprLGray-startMapSprites)/16
PERSON1LEFT                             = (sprPersonLeft1-startMapSprites)/16
PERSON1RIGHT                            = (sprPersonRight1-startMapSprites)/16
PERSON2LEFT                             = (sprPersonLeft2-startMapSprites)/16
PERSON2RIGHT                            = (sprPersonRight2-startMapSprites)/16
PERSON3LEFT                             = (sprPersonLeft3-startMapSprites)/16
PERSON3RIGHT                            = (sprPersonRight3-startMapSprites)/16
SAPPHIRA1UP                             = (sprSapphiraUp1-startMapSprites)/16
SAPPHIRA1DOWN                           = (sprSapphiraDown1-startMapSprites)/16
SAPPHIRA2UP                             = (sprSapphiraUp2-startMapSprites)/16
SAPPHIRA2DOWN                           = (sprSapphiraDown2-startMapSprites)/16
SAPPHIRA3UP                             = (sprSapphiraUp3-startMapSprites)/16
SAPPHIRA3DOWN                           = (sprSapphiraDown3-startMapSprites)/16
ROCK1                                   = (sprRock1-startMapSprites)/16
ROCK2                                   = (sprRock2-startMapSprites)/16
ROCK3                                   = (sprRock3-startMapSprites)/16
STONE1                                  = (sprStone1-startMapSprites)/16
STONE2                                  = (sprStone2-startMapSprites)/16
STONE3                                  = (sprStone3-startMapSprites)/16
SWAMP1                                  = (sprSwamp1-startMapSprites)/16
SWAMP2                                  = (sprSwamp2-startMapSprites)/16
WATER1                                  = (sprWater1-startMapSprites)/16
WATER2                                  = (sprWater2-startMapSprites)/16
WATERFALL1                              = (sprWaterFall1-startMapSprites)/16
WATERFALL2                              = (sprWaterFall2-startMapSprites)/16
WATERFALL3                              = (sprWaterFall3-startMapSprites)/16
WATERFALL4                              = (sprWaterFall4-startMapSprites)/16
WATERFALLSPLASH1                        = (sprWaterFallSplash1-startMapSprites)/16
WATERFALLSPLASH2                        = (sprWaterFallSplash2-startMapSprites)/16
WELL1                                   = (sprWell1-startMapSprites)/16
WELL2                                   = (sprWell2-startMapSprites)/16
WATERPT1                                = (sprPineTreesWater1T-startMapSprites)/16
WATERPT2                                = (sprPineTreesWater2T-startMapSprites)/16
WATERPTL1                               = (sprPineTreesWater1TL-startMapSprites)/16
WATERPTL2                               = (sprPineTreesWater2TL-startMapSprites)/16
WATERPTR1                               = (sprPineTreesWater1TR-startMapSprites)/16
WATERPTR2                               = (sprPineTreesWater2TR-startMapSprites)/16
TILEFLOOR                               = (sprTileFloor-startMapSprites)/16
BRICKPORTAL1                            = (sprBrickPortal1-startMapSprites)/16
BRICKPORTAL2                            = (sprBrickPortal2-startMapSprites)/16
HELLPORTAL1                             = (sprHellPortal1-startMapSprites)/16
HELLPORTAL2                             = (sprHellPortal2-startMapSprites)/16
BRICKFLOOR                              = (sprBrickFloor-startMapSprites)/16
BRICKFLOORWDOWN                         = (sprBrickFloorWDown-startMapSprites)/16
BRICKWALL                               = (sprBrickWall-startMapSprites)/16
STAIRSDOWNLEFT                          = (sprStairsDownLeft-startMapSprites)/16
STAIRSDOWNRIGHT                         = (sprStairsDownRight-startMapSprites)/16
BRIDGEV                                 = (sprBridgeV-startMapSprites)/16
WHITE                                   = 0

;------------------------------------------------
; Map animation table
;------------------------------------------------
animationTable:
; Normal water
.db     WATER1,WATER2, WATER2,WATER1
; Swamp water
.db     SWAMP1,SWAMP2, SWAMP2,SWAMP1
; Lava
.db     LAVA1,LAVA2, LAVA2,LAVA1
; Waterfall
.db     WATERFALL1,WATERFALL2, WATERFALL2,WATERFALL3, WATERFALL3,WATERFALL4, WATERFALL4,WATERFALL1
; Waterfall Splash
.db     WATERFALLSPLASH1,WATERFALLSPLASH2, WATERFALLSPLASH2,WATERFALLSPLASH1
; Water behind Pine Trees (Top)
.db     WATERPT1,WATERPT2, WATERPT2,WATERPT1
; Water behind Pine Trees (Top-left)
.db     WATERPTL1,WATERPTL2, WATERPTL2, WATERPTL1
; Water behind Pine Trees (Top-right)
.db     WATERPTR1,WATERPTR2, WATERPTR2, WATERPTR1
; Person 1
.db     PERSON1LEFT,PERSON1RIGHT, PERSON1RIGHT, PERSON1LEFT
; Person 2
.db     PERSON2LEFT,PERSON2RIGHT, PERSON2RIGHT, PERSON2LEFT
; Person 3
.db     PERSON3LEFT,PERSON3RIGHT, PERSON3RIGHT, PERSON3LEFT
; Sapphira 1
.db     SAPPHIRA1UP,SAPPHIRA1DOWN, SAPPHIRA1DOWN, SAPPHIRA1UP
; Sapphira 2
.db     SAPPHIRA2UP,SAPPHIRA2DOWN, SAPPHIRA2DOWN, SAPPHIRA2UP
; Sapphira 3
.db     SAPPHIRA3UP,SAPPHIRA3DOWN, SAPPHIRA3DOWN, SAPPHIRA3UP
; Well
.db     WELL1,WELL2, WELL2,WELL1
; Brick Portal
.db     BRICKPORTAL1,BRICKPORTAL2, BRICKPORTAL2,BRICKPORTAL1
; Hell Portal
.db     HELLPORTAL1,HELLPORTAL2, HELLPORTAL2, HELLPORTAL1
animationTableSize                      = ($-animationTable)/2

ONE_HEART                               = 32
NUMWARPS_OFFSET                         = 132

#include "animspr.asm"                          ; Animation Sprites
#include "areatxt.asm"                          ; Area Names
#include "demondat.asm"                         ; Demon Data
#include "demonspr.asm"                         ; Demon Sprites
#include "enemydat.asm"                         ; Enemy Data
#include "enemyspr.asm"                         ; Enemy Sprites
#include "invendat.asm"                         ; Inventory Screen Data
#include "invenspr.asm"                         ; Inventory Screen Sprites
#include "playrspr.asm"                         ; Player Sprites

stoneRockTiles:
.db     STONE1,STONE2,STONE3,ROCK1,ROCK2,ROCK3

replaceStoneRockTiles:
.db     DGRAY,LGRAY,WHITE,DGRAY,LGRAY,WHITE

swordCoords:
.db     3,-7
.db     2,14
.db     -7,2
.db     14,2

.end
